## hdrmerge 0.5%2Bgit20200117

=== debian/changelog ===
hdrmerge (0.5+git20200117-2build4) jammy; urgency=medium

  * No-change rebuild against libalglib3.18

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 06 Jan 2022 07:21:00 +0000

hdrmerge (0.5+git20200117-2build3) hirsute; urgency=medium

  * No-change rebuild to pick up new libraw soname

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Fri, 05 Mar 2021 14:57:38 +0100

hdrmerge (0.5+git20200117-2build2) hirsute; urgency=medium

  * No-change rebuild for alglib soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Jan 2021 15:38:12 +0100

hdrmerge (0.5+git20200117-2build1) focal; urgency=medium

  * No-change rebuild for exiv2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 04 Feb 2020 20:21:09 +0100

hdrmerge (0.5+git20200117-2) unstable; urgency=medium

  * Add Vcs fields.
  * Bump standards version to 4.5.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 03 Feb 2020 11:13:27 +0100

hdrmerge (0.5+git20200117-1) experimental; urgency=medium

  * Initial release. (Closes: #949362)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 17 Jan 2020 21:04:46 +0100

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

## hdrmerge 0.5+git20200117

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

cmake_policy(SET CMP0025 NEW)

project(hdrmerge)

if(WIN32)
    if(NOT(ALGLIB_ROOT))
        message(FATAL_ERROR "When building on Windows, you need to download 'alglib' source and define its root directory in ALGLIB_ROOT !")
    else()
        message(STATUS "ALGLIB_ROOT = ${ALGLIB_ROOT}")
    endif()
endif()

if(APPLE)
    if(NOT(ALGLIB_ROOT))
        message(FATAL_ERROR "Passage of ALGLIB_ROOT to cmake failed. Download alglib and define its root directory in ALGLIB_ROOT")
    else()
        message(STATUS "ALGLIB_ROOT = ${ALGLIB_ROOT}")
    endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wno-unknown-pragmas")
set(PLATFORM "")

# Required and optional packages
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${PROJECT_SOURCE_DIR}/cmake")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Generate resources automatically
set(CMAKE_AUTORCC ON)

find_package(Qt5 5.6 REQUIRED Core Widgets)

#include(${QT_USE_FILE})
add_definitions(${QT_DEFINITIONS})

find_package(LibRaw REQUIRED)
find_package(Exiv2 REQUIRED)
find_package(ZLIB REQUIRED)
find_package(OpenMP)

# Commented-out as it doesn't link
#find_package(Boost 1.46 COMPONENTS unit_test_framework)

if(WIN32)
    set(ALGLIB_INCLUDES ${ALGLIB_ROOT}/src)
else()
    find_package(Alglib REQUIRED)
endif()

include_directories(
    "${LibRaw_INCLUDE_DIR}"
    "${EXIV2_INCLUDE_DIR}"
    "${ZLIB_INCLUDE_DIRS}"
    "${ALGLIB_INCLUDES}"
)

if(NOT(CMAKE_BUILD_TYPE))
    set(CMAKE_BUILD_TYPE Release)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Release")
    if(OPENMP_FOUND)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    endif()
    if(CMAKE_COMPILER_IS_GNUCC)
        set(STRIP -s)
    endif()
endif()

# The version number.
set(HDRMERGE_VERSION_MAJOR 0)
set(HDRMERGE_VERSION_MINOR 5)
set(HDRMERGE_VERSION_REV 0)
set(HDRMERGE_VERSION ${HDRMERGE_VERSION_MAJOR}.${HDRMERGE_VERSION_MINOR}.${HDRMERGE_VERSION_REV})

# configure a header file to pass some of the CMake settings to the source code
configure_file(
    "${PROJECT_SOURCE_DIR}/src/config.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
)

# add the binary tree to the search path for include files so that we will find config.h
include_directories("${PROJECT_BINARY_DIR}")

set(PLATFORM_SOURCES "")
if(WIN32)
    # This is required by libraw.h
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWIN32 -DLIBRAW_NODLL")
    set(PLATFORM WIN32)
    configure_file(
        "${PROJECT_SOURCE_DIR}/data/winres.rc"
        "${PROJECT_BINARY_DIR}/winres.rc"
    )
    set(PLATFORM_SOURCES "${PROJECT_BINARY_DIR}/winres.rc")
elseif(APPLE)
    set(PLATFORM MACOSX_BUNDLE)
    set(MACOSX_BUNDLE_ICON_FILE "icon")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.hdrmerge")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING "HDRMerge for macOS v${HDRMERGE_VERSION}")
    set(MACOSX_BUNDLE_BUNDLE_NAME "HDRMerge")
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${HDRMERGE_VERSION}")
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${HDRMERGE_VERSION}")
    set(MACOSX_BUNDLE_INFO_COPYRIGHT "Copyright 2018 Javier Celaya")
    set(PLATFORM_SOURCES "data/images/icon.icns")
endif()

# Sources and headers
set(hdrmerge_sources
    src/Image.cpp
    src/ImageStack.cpp
    src/Bitmap.cpp
    src/RawParameters.cpp
    src/EditableMask.cpp
    src/DngFloatWriter.cpp
    src/TiffDirectory.cpp
    src/BoxBlur.cpp
    src/ExifTransfer.cpp
    src/ImageIO.cpp
)

set(hdrmerge_gui_sources
    src/AboutDialog.cpp
    src/MainWindow.cpp
    src/PreviewWidget.cpp
    src/DraggableScrollArea.cpp
    src/DngPropertiesDialog.cpp
    src/LoadOptionsDialog.cpp
    src/FileSystem.cpp
)

set(hdrmerge_qobject_headers
    src/MainWindow.hpp
    src/PreviewWidget.hpp
    src/LoadOptionsDialog.hpp
    src/DraggableScrollArea.hpp
    src/DngPropertiesDialog.hpp
    src/AboutDialog.hpp
    src/FileSystem.hpp
)

set(hdrmerge_translations
    data/hdrmerge_es.ts
)

if(WIN32)
    set(alglib_sources
        ${ALGLIB_ROOT}/src/alglibinternal.cpp
        ${ALGLIB_ROOT}/src/alglibmisc.cpp
        ${ALGLIB_ROOT}/src/ap.cpp
        ${ALGLIB_ROOT}/src/dataanalysis.cpp
        ${ALGLIB_ROOT}/src/diffequations.cpp
        ${ALGLIB_ROOT}/src/fasttransforms.cpp
        ${ALGLIB_ROOT}/src/integration.cpp
        ${ALGLIB_ROOT}/src/interpolation.cpp
        ${ALGLIB_ROOT}/src/linalg.cpp
        ${ALGLIB_ROOT}/src/optimization.cpp
        ${ALGLIB_ROOT}/src/solvers.cpp
        ${ALGLIB_ROOT}/src/specialfunctions.cpp
        ${ALGLIB_ROOT}/src/statistics.cpp
    )
endif()

if(APPLE)
    set(alglib_sources
        ${ALGLIB_ROOT}/src/alglibinternal.cpp
        ${ALGLIB_ROOT}/src/alglibmisc.cpp
        ${ALGLIB_ROOT}/src/ap.cpp
        ${ALGLIB_ROOT}/src/dataanalysis.cpp
        ${ALGLIB_ROOT}/src/diffequations.cpp
        ${ALGLIB_ROOT}/src/fasttransforms.cpp
        ${ALGLIB_ROOT}/src/integration.cpp
        ${ALGLIB_ROOT}/src/interpolation.cpp
        ${ALGLIB_ROOT}/src/linalg.cpp
        ${ALGLIB_ROOT}/src/optimization.cpp
        ${ALGLIB_ROOT}/src/solvers.cpp
        ${ALGLIB_ROOT}/src/specialfunctions.cpp
        ${ALGLIB_ROOT}/src/statistics.cpp
    )
endif()

# Libs
set(hdrmerge_libs
    "${LibRaw_r_LIBRARIES}"
    "${EXIV2_LIBRARY}"
    "${ZLIB_LIBRARIES}"
)

if(WIN32)
    get_filename_component(LIB_PATH "${EXIV2_LIBRARY}" PATH)
    find_library(EXPAT_LIBRARY libexpat.a "${LIB_PATH}")
    find_library(ICONV_LIBRARY libiconv.a "${LIB_PATH}")
    find_library(GETTEXT_LIBRARY libintl.a "${LIB_PATH}")
    set(hdrmerge_libs
        ${hdrmerge_libs}
        "${EXPAT_LIBRARY}"
        "${GETTEXT_LIBRARY}"
        "${ICONV_LIBRARY}"
        psapi
        wsock32
        imm32
        winmm
    )
    remove_definitions(-DQT_DLL)
else()
    set(hdrmerge_libs
        "${hdrmerge_libs}"
        "${ALGLIB_LIBRARIES}"
    )
endif()

#QT4_ADD_TRANSLATION(hdrmerge_qm ${hdrmerge_translations})

# Generate the XML version of hdrmerge_qm
foreach(file ${hdrmerge_qm})
    get_filename_component(basename ${file} NAME)
    set(HDRMERGE_QM_XML "${HDRMERGE_QM_XML}
    <file>${basename}</file>")
endforeach()

configure_file(
    "${PROJECT_SOURCE_DIR}/data/translations.qrc.in"
    "${PROJECT_BINARY_DIR}/translations.qrc"
)

if(WIN32)
    add_library(alglib-objects OBJECT ${alglib_sources})
endif()

if(APPLE)
    add_library(alglib-objects OBJECT ${alglib_sources})
endif()

if(WIN32)
    add_executable(hdrmerge ${PLATFORM}
        src/main.cpp
        src/Launcher.cpp
        data/resources.qrc
        ${hdrmerge_translations}
        ${hdrmerge_sources}
        ${hdrmerge_gui_sources}
        ${hdrmerge_moc}
        $<TARGET_OBJECTS:alglib-objects>
        "${PLATFORM_SOURCES}"
    )
elseif(APPLE)
    add_executable(hdrmerge ${PLATFORM}
        src/main.cpp
        src/Launcher.cpp
        data/resources.qrc
        $<TARGET_OBJECTS:alglib-objects>
        ${hdrmerge_translations}
        ${hdrmerge_sources}
        ${hdrmerge_gui_sources}
        ${hdrmerge_moc}
        "${PLATFORM_SOURCES}"
    )
else()
    add_executable(hdrmerge ${PLATFORM}
        src/main.cpp
        src/Launcher.cpp
        data/resources.qrc
        ${hdrmerge_translations}
        ${hdrmerge_sources}
        ${hdrmerge_gui_sources}
        ${hdrmerge_moc}
        "${PLATFORM_SOURCES}"
    )
endif()

target_link_libraries(hdrmerge ${STRIP} ${hdrmerge_libs} Qt5::Widgets)

if(WIN32)
    # Compile a target without GUI, for the .com executable
    add_executable(hdrmerge-nogui
        src/main.cpp
        src/Launcher.cpp
        data/resources.qrc
        ${hdrmerge_translations}
        ${hdrmerge_sources}
        ${hdrmerge_moc}
        $<TARGET_OBJECTS:alglib-objects>
        "${PLATFORM_SOURCES}"
    )
    
    # WARNING: ImageIO class need QImage which need Qt5::Widgets
    #          Launcher.cpp need QApplication which need Qt5::Widgets
    target_link_libraries(hdrmerge-nogui ${STRIP} ${hdrmerge_libs} Qt5::Widgets Qt5::Core)
    set_target_properties(hdrmerge-nogui PROPERTIES COMPILE_DEFINITIONS "NO_GUI")
    # Create the installer with makensis
    find_program(MAKENSIS_EXECUTABLE makensis.exe PATH_SUFFIXES "NSIS/Bin")
    if(MAKENSIS_EXECUTABLE)
        message(STATUS "NSIS found")
        set(SETUP_PROG hdrmerge-setup${WIN_ARCH}-${HDRMERGE_VERSION}.exe)
        string(REPLACE "/" "\\" PROJ_SRC_DIR "${PROJECT_SOURCE_DIR}")
        message(STATUS "PROJ_SRC_DIR       = ${PROJ_SRC_DIR}")

        # ASSUMING YOU'RE USING EXIV2 BUNDLED WITH MSYS2
        find_program(MINGW_LIB_DIR exiv2.exe)
        if(MINGW_LIB_DIR)
            get_filename_component(MINGW_LIB_DIR "${MINGW_LIB_DIR}" PATH)
            string(REPLACE "/" "\\" MINGW_LIB_DIR "${MINGW_LIB_DIR}")
            message(STATUS "MINGW_LIB_DIR      = ${MINGW_LIB_DIR}")

            set(QT5_PLUGINS_DIR "${MINGW_LIB_DIR}\\..\\share\\qt5\\plugins")
            message(STATUS "QT5_PLUGINS_DIR    = ${QT5_PLUGINS_DIR}")

            configure_file(
                "${PROJECT_SOURCE_DIR}/data/setup.nsi"
                "${PROJECT_BINARY_DIR}/setup.nsi" @ONLY
            )
            add_custom_command(OUTPUT ${SETUP_PROG}
                COMMAND "${MAKENSIS_EXECUTABLE}" -V2 setup.nsi
                MAIN_DEPENDENCY setup.nsi
                DEPENDS "${PROJECT_BINARY_DIR}/hdrmerge.exe"
                WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")
            add_custom_target(hdrmerge-setup ALL DEPENDS "${PROJECT_BINARY_DIR}/${SETUP_PROG}")
        else(MINGW_LIB_DIR)
            message(STATUS "Unable to locate the 'bin' directory to get the dependencies")
        endif(MINGW_LIB_DIR)
    else()
        message(STATUS "NSIS not found")
    endif()
elseif(APPLE)
    set_source_files_properties(data/images/icon.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    install(TARGETS hdrmerge BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
    if(NOT DEFINED CMAKE_INSTALL_BINDIR)
        set(CMAKE_INSTALL_BINDIR "bin")
    endif()
    message(STATUS "Install binary to: " ${CMAKE_INSTALL_BINDIR})
    install(TARGETS hdrmerge DESTINATION ${CMAKE_INSTALL_BINDIR})
    find_program(XDG-DESKTOP-MENU_EXECUTABLE xdg-desktop-menu)
    find_program(XDG-ICON-RESOURCE_EXECUTABLE xdg-icon-resource)
    if(XDG-DESKTOP-MENU_EXECUTABLE AND XDG-ICON-RESOURCE_EXECUTABLE)
        configure_file(
            "${PROJECT_SOURCE_DIR}/data/hdrmerge.desktop"
            "${PROJECT_BINARY_DIR}/hdrmerge.desktop"
        )
        install(CODE "
            execute_process(COMMAND \"${XDG-ICON-RESOURCE_EXECUTABLE}\" install --novendor --size 128 \"${PROJECT_SOURCE_DIR}/data/images/icon.png\" hdrmerge-icon)
            execute_process(COMMAND \"${XDG-DESKTOP-MENU_EXECUTABLE}\" install --novendor \"${PROJECT_BINARY_DIR}/hdrmerge.desktop\")"
        )
    endif()
endif()

if(Boost_FOUND)
    add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
include_directories(${Boost_INCLUDE_DIRS})

set(
    test_sources
    testMain.cpp
    testImageStack.cpp
    testBitmap.cpp
    testHistogram.cpp
    testBoxBlur.cpp
    testArray2D.cpp
    testDngFloatWriter.cpp
    )

#add_executable(hdrmerge-test ${test_sources} $<TARGET_OBJECTS:hdrmerge-objects> $<TARGET_OBJECTS:hdrmerge-gui-objects>)
add_executable(hdrmerge-test
    ${test_sources}
    )

if(APPLE)
    target_link_libraries(hdrmerge-test ${hdrmerge_libs} alglib-objects ${Boost_LIBRARIES} Qt5::Widgets)
else()
    target_link_libraries(hdrmerge-test ${hdrmerge_libs} ${Boost_LIBRARIES} Qt5::Widgets)
endif()

=== debian/changelog ===
hdrmerge (0.5+git20200117-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream commit 377d8e6f3c7cdd1a45b63bce2493ad177dde03fb to make
    hdrmerge compatible with Exiv2 0.28+; patch
    0001-Adapt-to-Exiv2-0.28.0-API-change.patch (Closes: #1071027)

 -- Pino Toscano <pino@debian.org>  Tue, 03 Sep 2024 07:22:48 +0200

hdrmerge (0.5+git20200117-4) unstable; urgency=medium

  * Ack NMU.
  * Bump standards version to 4.7.0.
  * Bump debhelper version to 13.

 -- Alex Myczko <tar@debian.org>  Sun, 16 Jun 2024 21:12:31 +0000

hdrmerge (0.5+git20200117-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/221.patch:
    - cherry-pick upstream proposed patch to fix gcc-13 build failure (Closes:
      #1037686)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 16 Jul 2023 21:12:40 +0200

hdrmerge (0.5+git20200117-3) unstable; urgency=medium

  * Team upload.

  * debian/patches/: patchset updated (Closes: #1040256)
    - 0001-Fix-LibRaw-0.21-API-change.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 07 Jul 2023 22:22:08 +0200

=== debian/control ===
Source: hdrmerge
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libalglib-dev, qtbase5-dev, libraw-dev, libexiv2-dev, zlib1g-dev
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/multimedia-team/hdrmerge.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hdrmerge
Homepage: https://github.com/jcelaya/hdrmerge

Package: hdrmerge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: HDR exposure merging
 This combines two or more raw images into a single raw with an extended
 dynamic range. It can import any raw image supported by LibRaw, and outputs
 a DNG 1.4 image with floating point data. The output raw is built from the
 less noisy pixels of the input, so that shadows maintain as much detail as
 possible. This tool also offers a GUI to remove ghosts from the resulting
 image.

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/jcelaya/hdrmerge/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
